<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="机台ID" prop="machineId">
        <el-input v-model="formData.machineId" placeholder="请输入机台ID" />
      </el-form-item>
      <el-form-item label="机台" prop="machineName">
        <el-input v-model="formData.machineName" placeholder="请输入机台" />
      </el-form-item>
      <el-form-item label="用户id" prop="workerId">
        <el-input v-model="formData.workerId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="用户" prop="workerName">
        <el-input v-model="formData.workerName" placeholder="请输入用户" />
      </el-form-item>
      <el-form-item label="类型" prop="resultType">
        <el-radio-group v-model="formData.resultType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_DATA_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="公式ID" prop="formulaId">
        <el-input v-model="formData.formulaId" placeholder="请输入公式ID" />
      </el-form-item>
      <el-form-item label="公式编号" prop="formulaCode">
        <el-input v-model="formData.formulaCode" placeholder="请输入公式编号" />
      </el-form-item>
      <el-form-item label="值" prop="dataValue">
        <el-input v-model="formData.dataValue" placeholder="请输入值" />
      </el-form-item>
      <el-form-item label="单位" prop="dataUnit">
        <el-input v-model="formData.dataUnit" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="采集时间" prop="deviceDataTime">
        <el-date-picker
          v-model="formData.deviceDataTime"
          type="date"
          value-format="x"
          placeholder="选择采集时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { FormulaRecordApi, FormulaRecordVO } from '@/api/iot/formula'

/** 变量记录 表单 */
defineOptions({ name: 'FormulaRecordForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  machineId: undefined,
  machineName: undefined,
  workerId: undefined,
  workerName: undefined,
  resultType: undefined,
  formulaId: undefined,
  formulaCode: undefined,
  dataValue: undefined,
  dataUnit: undefined,
})
const formRules = reactive({
  machineId: [{ required: true, message: '机台ID不能为空', trigger: 'blur' }],
  formulaId: [{ required: true, message: '公式ID不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FormulaRecordApi.getFormulaRecord(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as FormulaRecordVO
    if (formType.value === 'create') {
      await FormulaRecordApi.createFormulaRecord(data)
      message.success(t('common.createSuccess'))
    } else {
      await FormulaRecordApi.updateFormulaRecord(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    machineId: undefined,
    machineName: undefined,
    workerId: undefined,
    workerName: undefined,
    resultType: undefined,
    formulaId: undefined,
    formulaCode: undefined,
    dataValue: undefined,
    dataUnit: undefined,
  }
  formRef.value?.resetFields()
}
</script>
